import React, { useEffect, useMemo } from 'react'
import { InputNumber } from 'antd'

const NumberInput = (props) => {

  const { value, onChange, schema, addons } = props
  const { disabled, presetValue, placeholder, prefix, formatter } = schema

  useEffect(() => {
    if (addons) {
      addons.setValueByPath(addons.dataPath, presetValue || '0')
    } else {
      onChange(presetValue || '0')
    }
  }, [presetValue])

  const inputChange = (value) => {
    if (addons) {
      onChange(value + '')
    }
  }

  return (
    <InputNumber
      prefix={prefix}
      placeholder={placeholder}
      disabled={disabled}
      value={Number(value)}
      formatter={(value) => value && formatter ? `${value}${formatter}` : value}
      onChange={inputChange}
      style={{ width: '100%' }}
    />
  )

}

export default NumberInput